<template>
  <div class="main">
    <!-- Navigation -->
    <Navigation :getNews="getNews"/>

    <!-- Search bar -->
    <Search 
      :categories="categories"
      :countries="countries"
      @searchNews="searchNews"
    />
    
    <!-- Results -->
    <Result 
      :prev="prev"
      :next="next"
      :currentPage="currentPage"
      :pageCount="pageCount"
      :totalResults="totalResults"
      @newsSelected="newsSelected"
    />

    <!-- Modal -->
    <Modal 
      :open="openModal"
      :news="selectedNews"
      @close="close"
    />
  </div>
</template>

<script>
import { mapState } from 'vuex'
import Navigation from '@/components/Navigation.vue'
import Modal from '@/components/Modal.vue'
import Search from '@/components/Search.vue'
import Result from '@/components/Result.vue'

export default {
  components: {
    Modal,
    Navigation,
    Search,
    Result
  },
  created() {
    this.getNews()
    this.getCountries()
  },
  data() {
    return {
      form:null,
      selectedNews: null,
      currentPage: 1,
      maxPerPage: 10,
      openModal:false,
    }
  },
  computed: {
    ...mapState({
      categories: state => state.categories,
      countries: state => state.countries,
      totalResults: state => state.totalResults
    }),
    pageCount() {
      return Math.ceil(this.totalResults / this.maxPerPage)
    },
    isFirstPage() {
      return this.currentPage === 1
    },
    isLastPage() {
      return this.currentPage >= this.pageCount
    },
    getCountry() {
        if (this.form) {
          return this.form.country.toLowerCase()
        } else {
          return 'us'
        }
    },
    getCategory() {
      if (this.form) {
        return this.form.category.toLowerCase()
      } else {
        return 'general'
      }
    },
    getQuery() {
      if (this.form) {
        return this.form.query
      } else {
        return ''
      }
    },
  },
  methods: {
    newsSelected(news) {
      this.selectedNews = news;
      this.openModal = true;
    },
    close() {
      this.openModal = false
    },
    searchNews(searchObject) {
      this.resetPage();

      this.form = searchObject

      let data = {
        country: this.getCountry,
        category: this.getCategory,
        query: this.getQuery,
        page: this.currentPage,
        pageSize: this.maxPerPage,
      }

      this.$store.dispatch('getNews', data)
    },

    getNews() {
      this.resetPage();

      let data = {
        country: 'us',
        category: 'general',
        query:'',
        page: this.currentPage,
        pageSize: this.maxPerPage,
      }

      this.$store.dispatch('getNews', data)
    },
    getCountries() {
      this.$store.dispatch('getCountries')
    },
    
    getNewsPerPage() {
       let data = {
        country: this.getCountry,
        category: this.getCategory,
        query: this.getQuery,
        page: this.currentPage,
        pageSize: this.maxPerPage,
      }

      this.$store.dispatch('getNews', data)
    },
    resetPage() {
      this.currentPage = 1;
      this.maxPerPage = 20;
    },
    next() {
      if (this.isLastPage) return
      this.currentPage += 1;
      this.getNewsPerPage();
    },
    prev() {
      if (this.isFirstPage) return
      this.currentPage -= 1;
      this.getNewsPerPage();
    },
  },
}
</script>
